#*************************************************************
# Progamm:			fourier_1
# Sinn des Programms: 		Zeitreihenanalyse durch Fourieranalyse
# Sinn der Einheit  :		Ausgabeeinheit
# Name dieser Datei:		ausgabe.py
# Versionsnummer:		2
# Wird aufgerufen von:		fourier_1_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	6
# von:				6			
# Autor: 			Armin Ulrich
# Erster Lauf: 			03.11.2022
# Letzte Änderung: 		08.03.2023
#*************************************************************

import numpy as np

#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os

#*************************************************************
# Import der Klasse matplotlib.pyplot für die Graphikausgabe
#*************************************************************
import matplotlib.pyplot as plt

class Ausgabe:
  #Konstruktormethode
  def __init__(self):		
    print("Ausgabeobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt")  

#*************************************************************
# Funktion zur Ausgabe in der Konsole
#*************************************************************
  def schirm_ausgabe(self,m,x,y):
    print("Schirmaugabe")
    i_max = m - 1
    for i in range(i_max + 1):
      print ("%5i" %i,"%6.5f" %x[i], "%6.5f" %y[i])
      
      
  def spektrum_schirm_ausgabe(self,m,n, A_cos, B_sin):
    print("Schirmaugabe des Spektrums")
    print("Cosinusanteil")    
    for i in range(m):
      print ("%5i" %i, "%6.5f" %A_cos[i])
      
    for i in range(n):
      print ("%5i" %i, "%6.5f" %B_sin[i])      

  def parameter_datei_ausgabe(self,parameter_datei, m, x_min, x_max):
    fobj_out = open(parameter_datei,"w")    
    fobj_out.write(str("%5i" %m))
    fobj_out.write("\n")    
    fobj_out.write(str("%6.5f" %x_min)) 
    fobj_out.write("\n")    
    fobj_out.write(str("%6.5f" %x_max))             
    fobj_out.close()

#*************************************************************
# Funktion zur Ausgabe in eine Datei
#*************************************************************
  def datei_ausgabe(self, ausgabe_datei, m, x, y):
    i_max = m - 1
    fobj_out = open(ausgabe_datei,"w")
    for i in range(i_max + 1):
      fobj_out.write(str("%5i" %i))
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %x[i]))      
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %y[i])) 
      fobj_out.write("\n")
    fobj_out.close()


  def spektrum_datei_ausgabe(self, ausgabe_datei, m, n, A_cos, B_sin):
    
    fobj_out = open("spektrum_cosinusanteil_" + ausgabe_datei + ".dat","w")
    for i in range(m):
      fobj_out.write(str("%5i" %i))     
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %A_cos[i])) 
      fobj_out.write("\n")
    fobj_out.close()

    fobj_out = open("spektrum_sinusanteil_" + ausgabe_datei + ".dat","w") 
    for i in range(n):
      fobj_out.write(str("%5i" %i))   
      fobj_out.write("\t")
      fobj_out.write(str("%6.5f" %B_sin[i])) 
      fobj_out.write("\n")
    fobj_out.close()

#*************************************************************
# Funktion zur graphischen Ausgabe
#*************************************************************
  def graphik_ausgabe_funktion(self,m, x, y, graphik_datei_wähler, graphik_datei_format, graphik_datei, graphik_titel, graphik_abszisse,\
    graphik_ordinate):
    x_min=20000.0
    x_max=0.0
    y_min=0.0
    y_max=0.0
    i_max = m - 1
    for i in range(i_max+1):
      if x_min >= x[i]:
        x_min = x[i]
      if x_max <= x[i]:
        x_max = x[i]
      if y_min >= y[i]:
        y_min = y[i]
      if y_max <= y[i]:
        y_max = y[i]
    plt.plot(x, y,'r') #, 'r.'
      # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    x_min-=(x_max-x_min)/10.0
    x_max+=(x_max-x_min)/10.0
    y_min-=(y_max-y_min)/10.0
    y_max+=(y_max-y_min)/10.0
    plt.axis([x_min, x_max, y_min, y_max])
    plt.title(graphik_titel)
    plt.xlabel(graphik_abszisse)
    plt.ylabel(graphik_ordinate)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    if(graphik_datei_wähler):
      plt.savefig(graphik_datei + "." + graphik_datei_format, format=graphik_datei_format)
     # Diagramm anzeigen:
    plt.show()
    
  def graphik_ausgabe_spektrum(self,graphik_spektrum_datei, graphik_titel, spektrum_ausgabe_abszisse, spektrum_ausgabe_ordinate, m,n, grund_frequenz,\
    A_cos,B_sin, graphik_datei_wähler, graphik_datei_format):
    xwerte = np.arange(m)
    plt.title("Spektrum Cosinusanteil "+ graphik_titel)
    #bar_width = 0.00001
    plt.bar(xwerte, A_cos, color="blue")
    plt.xlabel("* " + str(grund_frequenz) + "  " + spektrum_ausgabe_abszisse)
    plt.ylabel(spektrum_ausgabe_ordinate)
    if(graphik_datei_wähler):
      plt.savefig("spektrum_cosinusanteil_" + graphik_spektrum_datei +"."+ graphik_datei_format, format=graphik_datei_format)
    plt.show()
    
    xwerte = np.arange(n)
    plt.title("Spektrum Sinusanteil "+ graphik_titel)
    #bar_width = 0.00001
    plt.bar(xwerte, B_sin, color="green")
    plt.xlabel("* " + str(grund_frequenz) + "  " + spektrum_ausgabe_abszisse)
    plt.ylabel(spektrum_ausgabe_ordinate)
    if(graphik_datei_wähler):
      plt.savefig("spektrum_sinusanteil_" + graphik_spektrum_datei + "."+ graphik_datei_format, format=graphik_datei_format)
    plt.show()

