#*************************************************************
# Progamm:			fourier_1
# Sinn des Programms: 		Zeitreihenanalyse durch Fourieranalyse
# Sinn der Einheit  :		Hauptprogramm	
# Name dieser Datei:		fourier_1_haupt.py
# Versionsnummer:		2
# Wird aufgerufen von:		-
# Ruft auf:			steuer.py, gitter.py, rechner.py, zurueck_rechner.py, ausgabe.py
# Nummer im Programmpaket:	1
# von:				6			
# Autor: 			Armin Ulrich
# Erster Lauf: 			03.11.2022
# Letzte Änderung: 		08.03.2023
#*************************************************************

#*************************************************************
# Importieren der Klassen zur Zeitdokumentation
#*************************************************************

import time
import datetime
import sys


#*************************************************************
# Importieren der Klassen
#*************************************************************
from steuer import Steuer
from datei_einlese import Datei_einlese
from rechner import Rechner
from zurueck_rechner import Zurück_Rechner
from ausgabe import Ausgabe

#*************************************************************
# Belegung der Klassen
#*************************************************************
steuer = Steuer()
datei_einlese = Datei_einlese()
rechner = Rechner()
zurück_rechner = Zurück_Rechner()
ausgabe = Ausgabe()


#*************************************************************
# Berechnung der Startzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Startzeit zu einem String "datum_zeit"
#*************************************************************
dt_start = datetime.datetime.now()
lt_start = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_start[0:6]
datum_zeit = "Datum: " +str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)


#*************************************************************
# öffnen der Log-Datei
#*************************************************************
fobj_log = open("fourier_analyse.log","w")

#*************************************************************
# Schreiben von Datum und Zeit des Programmstarts 
# in die Logdatei 
#*************************************************************
fobj_log.write("Anfang: "+ "\n" + datum_zeit)
fobj_log.write("\n")
#*************************************************************
# Prüfung, ob Steuerdatei erfolgreich geöffnet wurde
#*************************************************************
if(steuer.steuer_input()):
  fobj_log.write( "Einlesen der Steuerdatei funktionierte\n")
  if(datei_einlese.datei_input(steuer.eingabe_datei_1)):
    fobj_log.write( "Datei existiert\n")
    m_1=datei_einlese.m
    x_1=datei_einlese.x
    y_1=datei_einlese.y
    #print("x:",x_1)
    #print("y:",y_1)
  else:
    fobj_log.write( "Datei existiert nicht\n")

  if(datei_einlese.datei_input(steuer.eingabe_datei_2)):
    fobj_log.write( "Datei existiert\n")
    m_2=datei_einlese.m
    x_2=datei_einlese.x
    y_2=datei_einlese.y

    
    rechner.fourier(m_1, x_1, y_1)
    m_3 = rechner.N+2
    n_3 = rechner.N+1
    grund_frequenz_1 = rechner.grund_frequenz    
    A_cos_spektrum_1 = rechner.A_cos
    B_sin_spektrum_1 = rechner.B_sin

    zurück_rechner.fourier_zurück(m_1, x_1, rechner.A_cos, rechner.B_sin)
    x_1_neu = zurück_rechner.x_neu
    z_1 = zurück_rechner.F
    
    rechner.fourier(m_2, x_2, y_2)
    m_4 = rechner.N+2
    n_4 = rechner.N+1
    grund_frequenz_2 = rechner.grund_frequenz
    A_cos_spektrum_2 = rechner.A_cos
    B_sin_spektrum_2 = rechner.B_sin
    zurück_rechner.fourier_zurück(m_2,  x_2, rechner.A_cos, rechner.B_sin)    
    z_2 = zurück_rechner.F
    x_2_neu = zurück_rechner.x_neu

    ausgabe.parameter_datei_ausgabe(steuer.parameter_datei, m_1, x_1[0], x_1[m_1-1])

#*************************************************************
# Ausgabe der Lösung auf Schirm, in Datei, als Graphik 
#*************************************************************
    if steuer.schirm_ausgabe_wähler : 
      ausgabe.schirm_ausgabe(m_1,x_1,y_1)
      ausgabe.schirm_ausgabe(m_2,x_2,y_2)
      ausgabe.schirm_ausgabe(m_1,x_1_neu,z_1)
      ausgabe.schirm_ausgabe(m_2,x_2_neu,z_2)
    
      ausgabe.spektrum_schirm_ausgabe(rechner.N+2,rechner.N+1,A_cos_spektrum_1,B_sin_spektrum_1)
      ausgabe.spektrum_schirm_ausgabe(rechner.N+2,rechner.N+1,A_cos_spektrum_2,B_sin_spektrum_2)
    
    if steuer.datei_ausgabe_wähler: 
      ausgabe.datei_ausgabe(steuer.ausgabe_datei_1,m_1,x_1,y_1 )
      ausgabe.datei_ausgabe(steuer.ausgabe_datei_2,m_2,x_2,y_2 )
      ausgabe.datei_ausgabe(steuer.ausgabe_datei_fourier_1,m_1,x_1_neu,z_1 )
      ausgabe.datei_ausgabe(steuer.ausgabe_datei_fourier_2,m_2,x_2_neu,z_2 )
    
      ausgabe.spektrum_datei_ausgabe(steuer.spektrum_ausgabe_datei_1,rechner.N+2,rechner.N+1,A_cos_spektrum_1,B_sin_spektrum_1)
      ausgabe.spektrum_datei_ausgabe(steuer.spektrum_ausgabe_datei_2,rechner.N+2,rechner.N+1,A_cos_spektrum_2,B_sin_spektrum_2)
    
    if steuer.graphik_ausgabe_wähler: 
      ausgabe.graphik_ausgabe_funktion(m_1,x_1,y_1,steuer.graphik_datei_ausgabe_wähler, steuer.graphik_datei_format,\
      steuer.graphik_datei_1,steuer.graphik_titel_1, steuer.graphik_abszisse_1, steuer.graphik_ordinate_1)
      ausgabe.graphik_ausgabe_funktion(m_2,x_2,y_2,steuer.graphik_datei_ausgabe_wähler,steuer.graphik_datei_format,\
      steuer.graphik_datei_2,steuer.graphik_titel_2, steuer.graphik_abszisse_2, steuer.graphik_ordinate_2)
#*************************************************************  
      ausgabe.graphik_ausgabe_funktion(m_1,x_1_neu,z_1,steuer.graphik_datei_ausgabe_wähler,steuer.graphik_datei_format,\
      steuer.graphik_datei_fourier_1,steuer.graphik_titel_fourier_1, steuer.graphik_abszisse_fourier_1, steuer.graphik_ordinate_fourier_1)
      ausgabe.graphik_ausgabe_funktion(m_2,x_2_neu,z_2,steuer.graphik_datei_ausgabe_wähler,steuer.graphik_datei_format,steuer.graphik_datei_fourier_2,\
      steuer.graphik_titel_fourier_2, steuer.graphik_abszisse_fourier_2, steuer.graphik_ordinate_fourier_2)
      
      
      ausgabe.graphik_ausgabe_spektrum(steuer.spektrum_ausgabe_datei_1, steuer.graphik_titel_1, steuer.spektrum_ausgabe_abszisse_1,\
      steuer.spektrum_ausgabe_ordinate_1, m_3, n_3, grund_frequenz_1, A_cos_spektrum_1, B_sin_spektrum_1,steuer.graphik_datei_ausgabe_wähler,\
      steuer.graphik_datei_format)
      ausgabe.graphik_ausgabe_spektrum(steuer.spektrum_ausgabe_datei_2, steuer.graphik_titel_2, steuer.spektrum_ausgabe_abszisse_2,\
      steuer.spektrum_ausgabe_ordinate_2, m_4, n_4, grund_frequenz_2, A_cos_spektrum_2,\
      B_sin_spektrum_2,steuer.graphik_datei_ausgabe_wähler,steuer.graphik_datei_format)
#************************************************************* # 

    
  else:
    fobj_log.write( "Datei existiert nicht\n")


else:
  fobj_log.write( "Einlesen der Steuerdatei funktionierte nicht\n")

#*************************************************************
# Berechnung der Endzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Endzeit zu einem String "datum_zeit"
#*************************************************************
lt_end = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_end[0:6]
datum_zeit = "Datum: "+str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)
dt_end = datetime.datetime.now()

#*************************************************************
# Berechnung der Rechendauer mit dem Zeitdifferenzoperator 
# des Moduls datetime
#*************************************************************
dauer = dt_end - dt_start

#*************************************************************
# Schreiben von Datum und Zeit des Programmendes und der 
# Rechendauer in die Logdatei 
#*************************************************************
fobj_log.write("Ende: "+ "\n" +datum_zeit + "\n")
fobj_log.write("Rechendauer: "+ "\n" + str(dauer))

#*************************************************************
# Schließen der Logdatei
#*************************************************************
fobj_log.close()

#*************************************************************
#Programmende
#*************************************************************
