#*************************************************************
# Progamm:			fourier_1
# Sinn des Programms: 		Zeitreihenanalyse durch Fourieranalyse
# Sinn der Einheit  :		Steuereinheit
# Name dieser Datei:		steuer.py
# Versionsnummer:		2
# Wird aufgerufen von:		fourier_1_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	2
# von:				6			
# Autor: 			Armin Ulrich
# Erster Lauf: 			03.11.2022
# Letzte Änderung: 		02.03.2023
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os


class Steuer:
  #Konstruktormethode
  def __init__(self):		
    print("Steuerobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Steuerobjekt entfernt")  

#*************************************************************
# Abschalten der GUI-Funktionen nach Gebrauch
#*************************************************************     
  def ändern(self):
    self.eingabe_gui.destroy()   
    print(self.eingabe_neu())
        
  def ende(self):
    self.eingabe_gui.destroy()     
    
  def ende_neu(self):
    self.eingabe_gui_neu.destroy()  

#*************************************************************
# Funktion zum Öffnen der Steuerdatei und zum Auslesen der
# Steuerdaten
#*************************************************************
  def steuer_input(self):
    self.rückgabeliste = list(range(5))
    self.rückgabeliste[0] = True                                   # Einlesen von Steuerdatei korrekt            True/False
    self.rückgabeliste[1] = "Steuerdatei wurde korrekt gelesen"    # Fehlermeldung für Einlesen aus Steuerdatei  Text
    self.rückgabeliste[2] = False                                  # Manuelle Änderung                           True/False
    self.rückgabeliste[3] = True                                   # Manuelle Änderung korrekt                   True/False
    self.rückgabeliste[4] = "Keine Fehler in der Änderung"         # Fehlermeldung für manuelle Änderung         Text  
#*************************************************************
# Überprüfung ob die Steuerdatei existiert 
#*************************************************************
    if os.path.exists("steuer.txt"):
      print("Steuerdatei ist vorhanden")

#*************************************************************
# Importieren der Klassen zur graphischen Darstellung 
#*************************************************************    
      import tkinter
      self.eingabe_gui = tkinter.Tk()  
      print("Eingabedaten werden eingelesen")
      self.zeilen_zähler = 0
      fobj_in = open("steuer.txt","r")       
      for line in fobj_in:
        self.zeilen_zähler+=1
      fobj_in.close()  
      
      self.anzeige_liste = list(range(self.zeilen_zähler)) 
      self.zeilen_zähler = 0
#*************************************************************
# Öffnen der Steuerdatei
#*************************************************************
      fobj_in = open("steuer.txt","r") 
#*************************************************************
# Einlesen der Steuerdaten zeilenweise
#*************************************************************
      
      for zeile in fobj_in:
        self.anzeige_liste[self.zeilen_zähler] = zeile[:-1]
        if self.zeilen_zähler == 1:
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
          self.eingabe_datei_1 = zeile[:-1]
        if self.zeilen_zähler == 3:
          self.eingabe_datei_2 = zeile[:-1]
        if self.zeilen_zähler == 5:
          self.schirm_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 7:
          self.datei_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 9:
          self.graphik_ausgabe_wähler = self.bool_function(zeile[:-1])           
        if self.zeilen_zähler == 11:
          self.graphik_datei_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 13:
          self.graphik_datei_format = zeile[:-1]
          self.graphik_formate_zulässig = set(['eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'])
          if self.graphik_datei_format in self.graphik_formate_zulässig:
            pass
          else:
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Python unterstützt das Graphikformat nicht!\nProgramm bricht ab!"          
        if self.zeilen_zähler == 15:        
          self.parameter_datei = zeile[:-1]         
        if self.zeilen_zähler == 17:        
          self.ausgabe_datei_1 = zeile[:-1]
        if self.zeilen_zähler == 19:
          self.graphik_datei_1 = zeile[:-1]
        if self.zeilen_zähler == 21:
          self.graphik_titel_1 = zeile[:-1]
        if self.zeilen_zähler == 23:
          self.graphik_abszisse_1 = zeile[:-1]             
        if self.zeilen_zähler == 25:
          self.graphik_ordinate_1 = zeile[:-1]          
        if self.zeilen_zähler == 27:
          self.ausgabe_datei_2 = zeile[:-1]                   
        if self.zeilen_zähler == 29:
          self.graphik_datei_2 = zeile[:-1]
        if self.zeilen_zähler == 31:
          self.graphik_titel_2 = zeile[:-1]
        if self.zeilen_zähler == 33:
          self.graphik_abszisse_2 = zeile[:-1]          
        if self.zeilen_zähler == 35:
          self.graphik_ordinate_2 = zeile[:-1]
        if self.zeilen_zähler == 37:
          self.ausgabe_datei_fourier_1 = zeile[:-1]
        if self.zeilen_zähler == 39:
          self.graphik_datei_fourier_1 = zeile[:-1]
        if self.zeilen_zähler == 41:
          self.graphik_titel_fourier_1 = zeile[:-1] 
        if self.zeilen_zähler == 43:
          self.graphik_abszisse_fourier_1 = zeile[:-1]          
        if self.zeilen_zähler == 45:
          self.graphik_ordinate_fourier_1 = zeile[:-1]
        if self.zeilen_zähler == 47:
          self.ausgabe_datei_fourier_2 = zeile[:-1]
        if self.zeilen_zähler == 49:
          self.graphik_datei_fourier_2 = zeile[:-1]
        if self.zeilen_zähler == 51:
          self.graphik_titel_fourier_2 = zeile[:-1]
        if self.zeilen_zähler == 53:
          self.graphik_abszisse_fourier_2 = zeile[:-1]              
        if self.zeilen_zähler == 55:
          self.graphik_ordinate_fourier_2 = zeile[:-1]  
        if self.zeilen_zähler == 57:
          self.spektrum_ausgabe_datei_1 = zeile[:-1]
        if self.zeilen_zähler == 59:
          self.spektrum_ausgabe_abszisse_1 = zeile[:-1]          
        if self.zeilen_zähler == 61:
          self.spektrum_ausgabe_ordinate_1 = zeile[:-1]                    
        if self.zeilen_zähler == 63:
          self.spektrum_ausgabe_datei_2 = zeile[:-1]  
        if self.zeilen_zähler == 65:
          self.spektrum_ausgabe_abszisse_2 = zeile[:-1]          
        if self.zeilen_zähler == 67:
          self.spektrum_ausgabe_ordinate_2 = zeile[:-1]                                       
        self.zeilen_zähler += 1    
      fobj_in.close()

#*************************************************************
# Anzeigen der Steuerdaten mittels Label und Grid
#*************************************************************   
      for i in range(self.zeilen_zähler):            
        lb = tkinter.Label(self.eingabe_gui, text = self.anzeige_liste[i])
        
        if i % 2 == 0:
          lb.grid(row=int(i/2), column=0, padx='1', pady='1', sticky='ew')
          #lb["font"] = "Arial 6 bold"
        else:
          lb.grid(row=int((i-1)/2), column=1, padx='1', pady='1', sticky='ew')
        lb["font"] = "Arial 10"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        if i % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten und 
# zum Start der Berechnungen
#*************************************************************
      weiter_button = tkinter.Button(self.eingabe_gui, text = "weiter", command = self.ende)
      weiter_button.grid(row=int(i/2+1), column=0, padx='1', pady='1', sticky='ew')
      ändern_button = tkinter.Button(self.eingabe_gui, text = "Eingabe ändern", command = self.ändern)
      ändern_button.grid(row=int(i/2+1), column=1, padx='1', pady='1', sticky='ew')
      #Endlosschleife
      self.eingabe_gui.mainloop()
    
    else:
      self.rückgabeliste[1] = "Steuerdatei ist nicht vorhanden"  
      self.rückgabeliste[0] = False 
      
    self.rückgabewert = self.rückgabeliste[0]  
    return self.rückgabewert
    
    
  def übernahme(self): 
    dummy = self.änderungs_feld_eingabe_datei_1.get()
#*************************************************************
# Test ob in das Feld etwas eingeschrieben wurde
# wenn nicht, dann dummy != "" False
#*************************************************************    
    if dummy != "" and dummy != self.eingabe_datei_1:          
      self.eingabe_datei_1 = dummy
      self.rückgabeliste[2] = True
      print("eingabe_datei_1 geändert:", self.eingabe_datei_1) 
    else:
      print("Keine Änderung der Variablen eingabe_datei_1")

    dummy = self.änderungs_feld_eingabe_datei_2.get()
    if dummy != "" != self.eingabe_datei_2:  
      self.eingabe_datei_2 = dummy
      self.rückgabeliste[2] = True
      print("self.eingabe_datei_2 geändert:", self.eingabe_datei_2) 
    else:
      print("Keine Änderung der Variablen")  
       
    dummy = self.änderungs_feld_schirm_ausgabe_wähler.get()
    if dummy != "" and dummy != str(self.schirm_ausgabe_wähler): 
      self.schirm_ausgabe_wähler = self.bool_function(dummy)
      print("schirm_ausgabe_wähler geändert:",  self.schirm_ausgabe_wähler)
      self.rückgabeliste[2] = True 
    else:
      print("Keine Änderung der Variablen schirm_ausgabe_wähler geändert") 

    dummy = self.änderungs_feld_datei_ausgabe_wähler.get()
    if dummy != "" and dummy != str(self.datei_ausgabe_wähler):  
      self.datei_ausgabe_wähler =  self.bool_function(dummy)
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("datei_ausgabe_wähler geändert:", self.datei_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen datei_ausgabe_wähler") 

    dummy = self.änderungs_feld_graphik_ausgabe_wähler.get()
    if dummy != "" and dummy != str(self.graphik_ausgabe_wähler):  
      self.graphik_ausgabe_wähler = self.bool_function(dummy)
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("graphik_ausgabe_wähler geändert:", self.graphik_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen") 
      
    dummy = self.änderungs_feld_graphik_datei_ausgabe_wähler.get()
    if dummy != "" and dummy != str(self.graphik_datei_ausgabe_wähler):  
      self.graphik_datei_ausgabe_wähler = self.bool_function(dummy)
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("graphik_datei_ausgabe_wähler geändert:", self.graphik_datei_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen graphik_ausgabe_wähler") 
      
    dummy = self.änderungs_feld_graphik_datei_format.get()
    if dummy != "" and dummy != self.graphik_datei_format:
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten."   
      if dummy in self.graphik_formate_zulässig:
        self.graphik_datei_format = dummy
      else:
        self.rückgabeliste[3] = False 
        self.rückgabeliste[4] = "Fehler in Eingabe: Python unterstützt das Graphikformat nicht!\nProgramm rechnet mit dem Wert aus der Steuerdatei\
        weiter!"
      print("graphik_datei_format geändert:",  self.graphik_datei_format) 
    else:
      print("Keine Änderung der Variablen graphik_datei_format") 
      
    dummy = self.änderungs_feld_parameter_datei.get()
    if dummy != "" and dummy != self.parameter_datei:  
      self.parameter_datei = dummy
      self.rückgabeliste[2] = True
      print("self.parameter_datei geändert:", self.parameter_datei) 
    else:
      print("Keine Änderung der Variablen") 

    dummy = self.änderungs_feld_ausgabe_datei_1.get()
    if dummy != "" and dummy != self.ausgabe_datei_1:  
      self.ausgabe_datei_1 = dummy
      self.rückgabeliste[2] = True
      print("self.ausgabe_datei_1 geändert:", self.ausgabe_datei_1) 
    else:
      print("Keine Änderung der Variablen ausgabe_datei_1")  
      
    dummy = self.änderungs_feld_graphik_datei_1.get()
    if dummy != "" and dummy != self.graphik_datei_1:  
      self.graphik_datei_1 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_datei_1 geändert:", self.graphik_datei_1) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_graphik_titel_1.get()
    if dummy != "" and dummy != self.graphik_titel_1:  
      self.graphik_titel_1 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_titel_1 geändert:", self.graphik_titel_1) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_graphik_abszisse_1.get()
    if dummy != "" and dummy != self.graphik_abszisse_1:    
      self.graphik_abszisse_1 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_abszisse_1 geändert:", self.graphik_abszisse_1) 
    else:
      print("Keine Änderung der Variablen")   
            
    dummy = self.änderungs_feld_graphik_ordinate_1.get()
    if dummy != "" and dummy != self.graphik_ordinate_1:   
      self.graphik_ordinate_1 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_ordinate_1 geändert:", self.graphik_ordinate_1) 
    else:
      print("Keine Änderung der Variablen")        
      
                        
    dummy = self.änderungs_feld_ausgabe_datei_2.get()
    if dummy != "" and dummy != self.ausgabe_datei_2:  
      self.ausgabe_datei_2 = dummy
      self.rückgabeliste[2] = True
      print("self.ausgabe_datei_2 geändert:", self.ausgabe_datei_2) 
    else:
      print("Keine Änderung der Variablen ausgabe_datei_2")  
      
    dummy = self.änderungs_feld_graphik_datei_2.get()
    if dummy != "" and dummy != self.graphik_datei_2:  
      self.graphik_datei_2 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_datei_2 geändert:", self.graphik_datei_2) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_graphik_titel_2.get()
    if dummy != "" and dummy != self.graphik_titel_2:
      self.graphik_titel_2 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_titel_2 geändert:", self.graphik_titel_2) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_graphik_abszisse_2.get()
    if dummy != "" and dummy != self.graphik_abszisse_2:  
      self.graphik_abszisse_2 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_abszisse_2 geändert:", self.graphik_abszisse_2) 
    else:
      print("Keine Änderung der Variablen")        
            
    dummy = self.änderungs_feld_graphik_ordinate_2.get()
    if dummy != "" and dummy != self.graphik_ordinate_2: 
      self.graphik_ordinate_2 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_ordinate_2 geändert:", self.graphik_ordinate_2) 
    else:
      print("Keine Änderung der Variablen")          
       
    dummy = self.änderungs_feld_ausgabe_datei_fourier_1.get()
    if dummy != "" and dummy != self.ausgabe_datei_fourier_1:  
      self.ausgabe_datei_fourier_1 = dummy
      self.rückgabeliste[2] = True
      print("self.ausgabe_datei_fourier_1 geändert:", self.ausgabe_datei_fourier_1) 
    else:
      print("Keine Änderung der Variablen ausgabe_datei_fourier_1")  
      
    dummy = self.änderungs_feld_graphik_datei_fourier_1.get()
    if dummy != "" and dummy != self.graphik_datei_fourier_1:  
      self.graphik_datei_fourier_1 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_datei_fourier_1 geändert:", self.graphik_datei_fourier_1) 
    else:
      print("Keine Änderung der Variablen graphik_datei_fourier_1")  
      
    dummy = self.änderungs_feld_graphik_titel_fourier_1.get()
    if dummy != ""  and dummy != self.graphik_titel_fourier_1:
      self.graphik_titel_fourier_1 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_titel_fourier_1 geändert:", self.graphik_titel_fourier_1) 
    else:
      print("Keine Änderung der Variablen")  

    dummy = self.änderungs_feld_graphik_abszisse_fourier_1.get()
    if dummy != "" and dummy != self.graphik_abszisse_fourier_1:  
      self.graphik_abszisse_fourier_1 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_abszisse_fourier_1 geändert:", self.graphik_abszisse_fourier_1) 
    else:
      print("Keine Änderung der Variablen") 
            
    dummy = self.änderungs_feld_graphik_ordinate_fourier_1.get()
    if dummy != "" and dummy != self.graphik_ordinate_fourier_1:
      self.graphik_ordinate_fourier_1 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_ordinate_fourier_1 geändert:", self.graphik_ordinate_fourier_1) 
    else:
      print("Keine Änderung der Variablen")                            
                                    
    dummy = self.änderungs_feld_ausgabe_datei_fourier_2.get()
    if dummy != "" and dummy != self.ausgabe_datei_fourier_2: 
      self.ausgabe_datei_fourier_2 = dummy
      self.rückgabeliste[2] = True
      print("self.ausgabe_datei_fourier_2 geändert:", self.ausgabe_datei_fourier_2) 
    else:
      print("Keine Änderung der Variablen ausgabe_datei_fourier_2")  
      
    dummy = self.änderungs_feld_graphik_datei_fourier_2.get()
    if dummy != "" and dummy != self.graphik_datei_fourier_2:  
      self.graphik_datei_fourier_2 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_datei_fourier_2 geändert:", self.graphik_datei_fourier_2) 
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_graphik_titel_fourier_2.get()
    if dummy != "" and dummy != self.graphik_titel_fourier_2:  
      self.graphik_titel_fourier_2 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_titel_fourier_2 geändert:", self.graphik_titel_fourier_2) 
    else:
      print("Keine Änderung der Variablen") 
       
    dummy = self.änderungs_feld_graphik_abszisse_fourier_2.get()
    if dummy != ""  and dummy != self.graphik_abszisse_fourier_2:  
      self.graphik_abszisse_fourier_2 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_abszisse_fourier_2 geändert:", self.graphik_abszisse_fourier_2) 
    else:
      print("Keine Änderung der Variablen")      
     
    dummy = self.änderungs_feld_graphik_ordinate_fourier_2.get()
    if dummy != "" and dummy != self.graphik_ordinate_fourier_2:  
      self.graphik_ordinate_fourier_2 = dummy
      self.rückgabeliste[2] = True
      print("self.graphik_ordinate_fourier_2 geändert:", self.graphik_ordinate_fourier_2) 
    else:
      print("Keine Änderung der Variablen")      
    
    dummy = self.änderungs_feld_spektrum_ausgabe_datei_1.get()
    if dummy != "" and dummy != self.spektrum_ausgabe_datei_1: 
      self.spektrum_ausgabe_datei_1 = dummy
      self.rückgabeliste[2] = True
      print("self.spektrum_ausgabe_datei_1 geändert:", self.spektrum_ausgabe_datei_1) 
    else:
      print("Keine Änderung der Variablen")  

    dummy = self.änderungs_feld_spektrum_abszisse_1.get()
    if dummy != "" and dummy != self.self.spektrum_abszisse_1:  
      self.spektrum_abszisse_1 = dummy
      self.rückgabeliste[2] = True
      print("self.spektrum_abszisse_1 geändert:", self.spektrum_abszisse_1) 
    else:
      print("Keine Änderung der Variablen")      
     
    dummy = self.änderungs_feld_spektrum_ordinate_1.get()
    if dummy != "" and dummy != self.self.spektrum_ordinate_1:  
      self.spektrum_ordinate_1 = dummy
      self.rückgabeliste[2] = True
      print("self.spektrum_ordinate_1 geändert:", self.spektrum_ordinate_1) 
    else:
      print("Keine Änderung der Variablen")       
      
      
    dummy = self.änderungs_feld_spektrum_ausgabe_datei_2.get()
    if dummy != "" and dummy != self.spektrum_ausgabe_datei_2:  
      self.spektrum_ausgabe_datei_2 = dummy
      self.rückgabeliste[2] = True
      print("self.spektrum_ausgabe_datei_2 geändert:", self.spektrum_ausgabe_datei_2) 
    else:
      print("Keine Änderung der Variablen")    
      
    dummy = self.änderungs_feld_spektrum_abszisse_2.get()
    if dummy != "" and dummy != self.self.spektrum_abszisse_2:  
      self.spektrum_abszisse_2 = dummy
      self.rückgabeliste[2] = True
      print("self.spektrum_abszisse_2 geändert:", self.spektrum_abszisse_2) 
    else:
      print("Keine Änderung der Variablen")      
     
    dummy = self.änderungs_feld_spektrum_ordinate_2.get()
    if dummy != "" and dummy != self.self.spektrum_ordinate_2: 
      self.spektrum_ordinate_2 = dummy
      self.rückgabeliste[2] = True
      print("self.spektrum_ordinate_2 geändert:", self.spektrum_ordinate_2) 
    else:
      print("Keine Änderung der Variablen")           
#*************************************************************
# Abspeichern der veränderten Eingabedaten in eine neue Steuerdatei
#*************************************************************

   
    fobj_out = open("steuer_neu.txt","w")   
    fobj_out.write("Name der 1. Eingabedatei:\n")
    fobj_out.write(self.eingabe_datei_1)
    fobj_out.write("\n")
    fobj_out.write("Name der 2. Eingabedatei:\n")
    fobj_out.write(self.eingabe_datei_2) 
    fobj_out.write("\n")
    fobj_out.write("Bildschirmausgabe?\n")
    fobj_out.write(str(self.schirm_ausgabe_wähler))
    fobj_out.write("\n")
    fobj_out.write("Dateiausgabe?\n")
    fobj_out.write(str(self.datei_ausgabe_wähler))
    fobj_out.write("\n")
    fobj_out.write("Graphikausgabe?\n")
    fobj_out.write(str(self.graphik_ausgabe_wähler))
    fobj_out.write("\n")
    fobj_out.write("Graphikdateiausgabe?\n")
    fobj_out.write(str(self.graphik_datei_ausgabe_wähler))
    fobj_out.write("\n")
    fobj_out.write("Graphikdateiausgabeformat?\n")
    fobj_out.write(str(self.graphik_datei_format))
    fobj_out.write("\n") 
    fobj_out.write("Parameterdatei:\n")
    fobj_out.write(self.parameter_datei)
    fobj_out.write("\n")    
    fobj_out.write("1. Ausgabedatei:\n")
    fobj_out.write(self.ausgabe_datei_1)
    fobj_out.write("\n")
    fobj_out.write("1. Graphikausgabedatei:\n")
    fobj_out.write(self.graphik_datei_1)
    fobj_out.write("\n")
    fobj_out.write("1. Graphiktitel:\n")
    fobj_out.write(self.graphik_titel_1)
    fobj_out.write("\n")
    fobj_out.write("1. Graphikabszisse:\n")
    fobj_out.write(self.graphik_abszisse_1)
    fobj_out.write("\n")      
    fobj_out.write("1. Graphikordinate:\n")
    fobj_out.write(self.graphik_ordinate_1)
    fobj_out.write("\n")  
    fobj_out.write("2. Ausgabedatei:\n")
    fobj_out.write(self.ausgabe_datei_2)
    fobj_out.write("\n")
    fobj_out.write("2. Graphikausgabedatei:\n")
    fobj_out.write(self.graphik_datei_2)
    fobj_out.write("\n")
    fobj_out.write("2. Graphiktitel:\n")
    fobj_out.write(self.graphik_titel_2)
    fobj_out.write("\n")
    fobj_out.write("2. Graphikabszisse:\n")
    fobj_out.write(self.graphik_abszisse_2)
    fobj_out.write("\n")    
    fobj_out.write("2. Graphikordinate:\n")
    fobj_out.write(self.graphik_ordinate_2)
    fobj_out.write("\n")
    fobj_out.write("1. Ausgabedatei Fourier:\n")
    fobj_out.write(self.ausgabe_datei_fourier_1)
    fobj_out.write("\n")
    fobj_out.write("1. Graphikausgabedatei Fourier:\n")
    fobj_out.write(self.graphik_datei_fourier_1)
    fobj_out.write("\n")
    fobj_out.write("1. Graphiktitel Fourier:\n")
    fobj_out.write(self.graphik_titel_fourier_1)
    fobj_out.write("\n")
    fobj_out.write("1. Graphikabszisse Fourier:\n")
    fobj_out.write(self.graphik_abszisse_fourier_1)
    fobj_out.write("\n")    
    fobj_out.write("1. Graphikordinate Fourier:\n")
    fobj_out.write(self.graphik_ordinate_fourier_1)
    fobj_out.write("\n") 
    fobj_out.write("2. Ausgabedatei Fourier:\n")
    fobj_out.write(self.ausgabe_datei_fourier_2)
    fobj_out.write("\n")
    fobj_out.write("2. Graphikausgabedatei Fourier:\n")
    fobj_out.write(self.graphik_datei_fourier_2)
    fobj_out.write("\n")
    fobj_out.write("2. Graphiktitel Fourier:\n")
    fobj_out.write(self.graphik_titel_fourier_2)
    fobj_out.write("\n")
    fobj_out.write("2. Graphikabszisse Fourier:\n")
    fobj_out.write(self.graphik_abszisse_fourier_2)
    fobj_out.write("\n")    
    fobj_out.write("2. Graphikordinate Fourier:\n")
    fobj_out.write(self.graphik_ordinate_fourier_2)
    fobj_out.write("\n")  
    fobj_out.write("1. Spektrumdatei:\n")
    fobj_out.write(self.spektrum_ausgabe_datei_1 )
    fobj_out.write("\n")     
    fobj_out.write("1. Spektrumabszisse:\n")
    fobj_out.write(self.spektrum_ausgabe_abszisse_1 )
    fobj_out.write("\n") 
    fobj_out.write("1. Spektrumordinate:\n")
    fobj_out.write(self.spektrum_ausgabe_ordinate_1 )
    fobj_out.write("\n")     
    fobj_out.write("2. Spektrumdatei:\n")
    fobj_out.write(self.spektrum_ausgabe_datei_2 )
    fobj_out.write("\n")     
    fobj_out.write("2. Spektrumabszisse:\n")
    fobj_out.write(self.spektrum_ausgabe_abszisse_2 )
    fobj_out.write("\n") 
    fobj_out.write("2. Spektrumordinate:\n")
    fobj_out.write(self.spektrum_ausgabe_ordinate_2 )
    fobj_out.write("\n")                                  
    fobj_out.close   

                             
#*************************************************************
# Anzeigen der Steuerdaten mittels Label und Grid
# sowie der Möglichkeit, andere Eingabedaten einzugeben
#*************************************************************    
  def eingabe_neu(self):
    try:
      import tkinter
      self.eingabe_gui_neu = tkinter.Tk() 
      for i in range(self.zeilen_zähler):            
        lb = tkinter.Label(self.eingabe_gui_neu, text = self.anzeige_liste[i])
        if i % 2 == 0:
          lb.grid(row=int(i/2), column=0, padx='1', pady='1', sticky='ew')
        else:
          lb.grid(row=int((i-1)/2), column=1, padx='1', pady='1', sticky='ew')
        
        lb["font"] = "Arial 10"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        if i % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"  
      # Radio-Button-Variablen
      self.schirm_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.schirm_ausgabe_wähler_zwischen.set(str(self.schirm_ausgabe_wähler))
      self.datei_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.datei_ausgabe_wähler_zwischen.set(str(self.datei_ausgabe_wähler))      
      self.graphik_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.graphik_ausgabe_wähler_zwischen.set(str(self.graphik_ausgabe_wähler))  
      self.graphik_datei_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.graphik_datei_ausgabe_wähler_zwischen.set(str(self.graphik_datei_ausgabe_wähler))          
      self.graphik_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.graphik_ausgabe_wähler_zwischen.set(str(self.graphik_ausgabe_wähler))  
      self.graphik_datei_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.graphik_datei_ausgabe_wähler_zwischen.set(str(self.graphik_datei_ausgabe_wähler))       
            
      self.änderungs_feld_eingabe_datei_1 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_eingabe_datei_2 = tkinter.Entry(self.eingabe_gui_neu)
# Radio_button     
      self.änderungs_feld_schirm_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.schirm_ausgabe_wähler_zwischen,\
      value = "True")
      self.änderungs_feld_schirm_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.schirm_ausgabe_wähler_zwischen,\
      value = "False")  
      self.änderungs_feld_datei_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.datei_ausgabe_wähler_zwischen,\
      value = "True")
      self.änderungs_feld_datei_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.datei_ausgabe_wähler_zwischen,\
      value = "False")  
# Radio_button 
      self.änderungs_feld_graphik_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.graphik_ausgabe_wähler_zwischen,\
      value = "True")
      self.änderungs_feld_graphik_ausgabe_wähler_2 =tkinter.Radiobutton(self.eingabe_gui_neu,text="Nein",variable=self.graphik_ausgabe_wähler_zwischen,\
      value = "False")                
# Radio_button 
      self.änderungs_feld_graphik_datei_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu,\
      text="Ja",variable=self.graphik_datei_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_graphik_datei_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu,\
      text="Nein",variable=self.graphik_datei_ausgabe_wähler_zwischen, value = "False")   
      
      self.änderungs_feld_graphik_datei_format = tkinter.Entry(self.eingabe_gui_neu) 
      self.änderungs_feld_parameter_datei = tkinter.Entry(self.eingabe_gui_neu)           
      self.änderungs_feld_ausgabe_datei_1 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_datei_1 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_titel_1 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_abszisse_1 = tkinter.Entry(self.eingabe_gui_neu)      
      self.änderungs_feld_graphik_ordinate_1 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_ausgabe_datei_2  = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_datei_2  = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_titel_2 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_abszisse_2 = tkinter.Entry(self.eingabe_gui_neu)       
      self.änderungs_feld_graphik_ordinate_2 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_ausgabe_datei_fourier_1 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_datei_fourier_1 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_titel_fourier_1 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_abszisse_fourier_1 = tkinter.Entry(self.eingabe_gui_neu)      
      self.änderungs_feld_graphik_ordinate_fourier_1 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_ausgabe_datei_fourier_2 = tkinter.Entry(self.eingabe_gui_neu) 
      self.änderungs_feld_graphik_datei_fourier_2 = tkinter.Entry(self.eingabe_gui_neu)      
      self.änderungs_feld_graphik_titel_fourier_2 = tkinter.Entry(self.eingabe_gui_neu)     
      self.änderungs_feld_graphik_abszisse_fourier_2 = tkinter.Entry(self.eingabe_gui_neu)       
      self.änderungs_feld_graphik_ordinate_fourier_2 = tkinter.Entry(self.eingabe_gui_neu)            
      self.änderungs_feld_spektrum_ausgabe_datei_1 = tkinter.Entry(self.eingabe_gui_neu) 
      self.änderungs_feld_spektrum_abszisse_1 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_spektrum_ordinate_1 = tkinter.Entry(self.eingabe_gui_neu)                 
      self.änderungs_feld_spektrum_ausgabe_datei_2 = tkinter.Entry(self.eingabe_gui_neu) 
      self.änderungs_feld_spektrum_abszisse_2 = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_spektrum_ordinate_2 = tkinter.Entry(self.eingabe_gui_neu)


                        
      self.änderungs_feld_eingabe_datei_1.grid(row=0, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')    
      self.änderungs_feld_eingabe_datei_2.grid(row=1, column=2, columnspan = 2, padx='1', pady='1', sticky='ew') 
# Radio_button
      self.änderungs_feld_schirm_ausgabe_wähler_1.grid(row=2, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_schirm_ausgabe_wähler_2.grid(row=2, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_schirm_ausgabe_wähler = self.schirm_ausgabe_wähler_zwischen 
#      self.änderungs_feld_datei_ausgabe_wähler.grid(row=12, column=2, padx='1', pady='1', sticky='ew')  
# Radio_button
      self.änderungs_feld_datei_ausgabe_wähler_1.grid(row=3, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_datei_ausgabe_wähler_2.grid(row=3, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_datei_ausgabe_wähler = self.datei_ausgabe_wähler_zwischen 
# Radio_button
      self.änderungs_feld_graphik_ausgabe_wähler_1.grid(row=4, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_ausgabe_wähler_2.grid(row=4, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_ausgabe_wähler = self.graphik_ausgabe_wähler_zwischen
            
#      self.änderungs_feld_graphik_datei_ausgabe_wähler.grid(row=17, column=2, padx='1', pady='1', sticky='ew')
# Radio_button
      self.änderungs_feld_graphik_datei_ausgabe_wähler_1.grid(row=5, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_datei_ausgabe_wähler_2.grid(row=5, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_datei_ausgabe_wähler = self.graphik_datei_ausgabe_wähler_zwischen 
      self.änderungs_feld_graphik_datei_format.grid(row=6, column=2, columnspan = 2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_parameter_datei.grid(row=7, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')            
      self.änderungs_feld_ausgabe_datei_1.grid(row=8, column=2, columnspan = 2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_datei_1.grid(row=9, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_graphik_titel_1.grid(row=10, column=2, columnspan = 2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_abszisse_1.grid(row=11, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')      
      self.änderungs_feld_graphik_ordinate_1.grid(row=12, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_ausgabe_datei_2.grid(row=13, column=2, columnspan = 2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_datei_2.grid(row=14, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_graphik_titel_2.grid(row=15, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')   
      self.änderungs_feld_graphik_abszisse_2.grid(row=16, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')       
      self.änderungs_feld_graphik_ordinate_2.grid(row=17, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_ausgabe_datei_fourier_1.grid(row=18, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_graphik_datei_fourier_1.grid(row=19, column=2, columnspan = 2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_titel_fourier_1.grid(row=20, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')               
      self.änderungs_feld_graphik_ordinate_fourier_1.grid(row=21, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_graphik_abszisse_fourier_1.grid(row=22, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')           
      self.änderungs_feld_ausgabe_datei_fourier_2.grid(row=23, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_graphik_datei_fourier_2.grid(row=24, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_graphik_titel_fourier_2.grid(row=25, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_graphik_abszisse_fourier_2.grid(row=26, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')      
      self.änderungs_feld_graphik_ordinate_fourier_2.grid(row=27, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')     
      self.änderungs_feld_spektrum_ausgabe_datei_1.grid(row=28, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_spektrum_abszisse_1.grid(row=29, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_spektrum_ordinate_1.grid(row=30, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')            
      self.änderungs_feld_spektrum_ausgabe_datei_2.grid(row=31, column=2, columnspan = 2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_spektrum_abszisse_2.grid(row=32, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_spektrum_ordinate_2.grid(row=33, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
                         
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten
# Button zur Übernahme der geänderten Eingabedaten
# zum Start der Berechnungen
#*************************************************************      
      weiter_button = tkinter.Button(self.eingabe_gui_neu, text = "weiter", command = self.ende_neu)
      weiter_button.grid(row=34, column=0, padx='1', pady='1', sticky='ew')
      übernahme_button = tkinter.Button(self.eingabe_gui_neu, text = "übernehmen", command = self.übernahme)
      übernahme_button.grid(row=34, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      
      #Endlosschleife
      self.eingabe_gui_neu.mainloop()
           
      print("Einlesen o.k.")
      self.rückgabewert = True
  
    except:
      print("Fehler beim Dateieinlesen")
      self.rückgabewert = False
    return self.rückgabewert   

      
  def bool_function(self,arg):
    s_true = set(["True", "true", "T", "t", "1" ])
    s_false = set(["False", "false", "F", "f", "0" ])
    if arg in s_true:
      return True
    elif arg in s_false:
      return False
    else:     
      return True


