#*************************************************************
# Progamm:			fourier_1
# Sinn des Programms: 		Zeitreihenanalyse durch Fourieranalyse
# Sinn der Einheit  :		Recheneinheit zur Zurückrechnung der Funktion aus dem Spektrum	
# Name dieser Datei:		zurueck_rechner.py
# Versionsnummer:		1
# Wird aufgerufen von:		fourier_1_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				6			
# Autor: 			Armin Ulrich
# Erster Lauf: 			03.11.2022
# Letzte Änderung: 		03.11.2022
#*************************************************************

import math
import numpy as np


class Zurück_Rechner:
  #Konstruktormethode
  def __init__(self):		
    print("Rechnerobjekt erzeugt")
    
  
  #Destruktormethode
  def __del__(self):	
    print("Rechnerobjekt entfernt")  
    

  def fourier_zurück(self, m, x, A_cos, B_sin):
  # m im Zurmühl und Überhuber: 2*N =>
    self.N=int(m/2)

    B_sin[0] = 0.0
    self.theta =np.zeros(2*self.N) 		#Zurmühl Gl. (10)
    self.F= np.zeros(2*self.N) 

    for j in range(2*self.N): 			#Zurmühl Gl. (10)
      self.theta[j] = j*math.pi/float(self.N) 	#Zurmühl Gl. (10)
      
    for j in range(2*self.N):
      self.F[j] = A_cos[0]
      for nue in range(1,self.N):
        self.F[j] += (A_cos[nue]*math.cos(float(nue)*self.theta[j]) + B_sin[nue]*math.sin(float(nue)*self.theta[j]))

# x_neu aus theta
    self.x_neu =np.zeros(2*self.N)

    for j in range(2*self.N):
      self.x_neu[j] = x[0] + (self.theta[j]/(self.theta[2*self.N-1])) * (x[m-1] - x[0])
